'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var varint = require('varint');
var dagCbor = require('@ipld/dag-cbor');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var varint__default = /*#__PURE__*/_interopDefaultLegacy(varint);

function createEncoder(writer) {
  return {
    async setRoots(roots) {
      const header = dagCbor.encode({
        version: 1,
        roots
      });
      await writer.write(new Uint8Array(varint__default['default'].encode(header.length)));
      await writer.write(header);
    },
    async writeBlock(block) {
      const {cid, bytes} = block;
      await writer.write(new Uint8Array(varint__default['default'].encode(cid.bytes.length + bytes.length)));
      await writer.write(cid.bytes);
      await writer.write(bytes);
    },
    async close() {
      return writer.end();
    }
  };
}

exports.createEncoder = createEncoder;
