import varint from 'varint';
import { encode as dagCborEncode } from '@ipld/dag-cbor';
function createEncoder(writer) {
  return {
    async setRoots(roots) {
      const header = dagCborEncode({
        version: 1,
        roots
      });
      await writer.write(new Uint8Array(varint.encode(header.length)));
      await writer.write(header);
    },
    async writeBlock(block) {
      const {cid, bytes} = block;
      await writer.write(new Uint8Array(varint.encode(cid.bytes.length + bytes.length)));
      await writer.write(cid.bytes);
      await writer.write(bytes);
    },
    async close() {
      return writer.end();
    }
  };
}
export {
  createEncoder
};